%define _testsdir %{_libexecdir}/lutok/tests

Summary: Lightweight C++ API library for Lua
Name:    lutok
Version: 0.4
Release: 3%{?dist}
License: BSD
URL:     http://code.google.com/p/lutok/
Source0: http://lutok.googlecode.com/files/lutok-%{version}.tar.gz

BuildRequires: gcc-c++ gcc libatf-c++-devel lua-devel make

Requires: lua >= 5.2

%description
Lutok provides thin C++ wrappers around the Lua C API to ease the interaction between C++ and Lua.
These wrappers make intensive use of RAII to prevent resource leakage, expose C++-friendly data
types, report errors by means of exceptions and ensure that the Lua stack is always left untouched
in the face of errors.  The library also provides a small subset of miscellaneous utility functions
built on top of the wrappers.

Lutok focuses on providing a clean and safe C++ interface; the drawback is that it is not suitable
for performance-critical environments.  In  order to implement error-safe C++ wrappers on top of a
Lua C binary library, Lutok adds several layers or abstraction and error checking that go against
the original spirit of the Lua C API and thus degrade performance.

%package devel
Summary: Libraries and header files for Lutok development
Requires: %{name} = %{version}-%{release}
Requires: lua-devel >= 5.1

%description devel
Provides the libraries and header files to develop applications that use the Lutok C++ API to Lua.

%package tests
Summary: Run-time tests of the Lutok library
Requires: %{name} = %{version}-%{release}
Requires: %{name}-devel = %{version}-%{release}
Requires: libatf-c++ >= 0.20

%description tests
This package installs the run-time tests for the Lutok library.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%configure \
    --disable-static \
    --without-doxygen \
    %{nil}

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make_build testsdir=%{_testsdir}

%install
%make_install testsdir=%{_testsdir}
rm -f %{buildroot}%{_libdir}/liblutok.la
rm -rf %{buildroot}%{_defaultdocdir}

%check

%files
%license COPYING
%doc AUTHORS NEWS README
%{_libdir}/liblutok.so.3
%{_libdir}/liblutok.so.3.0.0

%files devel
%{_includedir}/lutok
%{_libdir}/liblutok.so
%{_libdir}/pkgconfig/lutok.pc

%files tests
%{_testsdir}

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 2 2023 Shuo Wang <abushwang@tencent.com> - 0.4-1
- initial build
